﻿using System;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace RadPropertyGridExample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radPropertyGrid1.SelectedObject = new SomeClass();

            this.radPropertyGrid1.KeyDown += new KeyEventHandler(radPropertyGrid1_KeyDown);
            this.radPropertyGrid1.EditorInitialized += new PropertyGridItemEditorInitializedEventHandler(radPropertyGrid1_EditorInitialized);
        }

        void radPropertyGrid1_EditorInitialized(object sender, PropertyGridItemEditorInitializedEventArgs e)
        {
            BaseInputEditor editor = e.Editor as BaseInputEditor;
            RadTextBoxItem item = editor.EditorElement.FindDescendant<RadTextBoxItem>();

            if (item != null)
            {
                item.HostedControl.PreviewKeyDown += new PreviewKeyDownEventHandler(HostedControl_PreviewKeyDown);
            }
        }

        void HostedControl_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
        {
            if (e.KeyCode == Keys.Tab)
            {
                BaseInputEditor editor = this.radPropertyGrid1.ActiveEditor as BaseInputEditor;
                RadTextBoxItem item = editor.EditorElement.FindDescendant<RadTextBoxItem>();

                if (item != null)
                {
                    item.HostedControl.PreviewKeyDown -= HostedControl_PreviewKeyDown;
                }

                this.SelectNextItem();
            }
        }

        void radPropertyGrid1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Tab)
            {
                e.Handled = true;
                e.SuppressKeyPress = true;

                this.SelectNextItem();
            }
        }

        private void SelectNextItem()
        {
            int index = this.radPropertyGrid1.Items.IndexOf(this.radPropertyGrid1.SelectedGridItem as PropertyGridItem);

            if (index < this.radPropertyGrid1.Items.Count - 1)
            {
                index++;
            }
            else
            {
                index = 0;
            }

            this.radPropertyGrid1.SelectedGridItem = this.radPropertyGrid1.Items[index];
            this.radPropertyGrid1.BeginEdit();
            SendKeys.Send("{TAB}");
        }
    }

    public class SomeClass
    {
        public string T { get; set; }
        public string A { get; set; }
        public string B { get; set; }
    }
}
